/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.8d Professional
Automatic Program Generator
 Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 24.04.2007
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATmega32
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 512
*****************************************************/
/*
   rc5dec.c 0.2.0 - Interrupt driven RC5 decoder for Atmel AVR C's.
   Website: http://markh.de/rc5dec/
   Copyright (C) 2003  Mark Haemmerling <rc5@markh.de>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Preconfigured for INT1 (PD3) and Timer/Counter0.
*/

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega32

sfrb TWBR=0;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADCSR=6;     // for compatibility with older code
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2005 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions


// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega32






// ONLY for CodeVisionAVR C Compiler
/* (C) Termo  avr123.nm.ru 


   ?     mail.ru  bbigmak 
 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      
 ATmega8 ATmega16 ATmega32 ATmega64 ATmega128

  DataSheets  2004/12/19 


    :  CVAVR\inc

        :

#include <mega16.h>  //       

#include <m8_128.h>

      
         .

+++++++++++++++++++++++++++++++++++++++++++++++++++++++

         

b_1010_1100      0b10101100
     
======================================================

 Found errors ? E-mail me to mail.ru for bbigmak 

 ALL BIT's definitions for ATmega8 ATmega16 
                           ATmega32 ATmega64 ATmega128

 from DataSheets at 2004/12/19 


Put this file into CVAVR\inc
and include this file after 
standart heder file for MCU

Example:

#include <mega16.h>

#include <m8_128.h>



NOW you can use:    b_1010_1100  

insted of less clearly  0b10101100


*/

///////////////////////////////////////////////





/*
Type	Size (Bits)	Range  from CodeVisionAVR help
bit	1	0 , 1
char	8	-128 to 127
unsigned char	8	0 to 255
signed char	8	-128 to 127
int	16	-32768 to 32767
short int	16	-32768 to 32767
unsigned int	16	0 to 65535
signed int	16	-32768 to 32767
long int	32	-2147483648 to 2147483647
unsigned long int	32	0 to 4294967295
signed long int	32	-2147483648 to 2147483647
float	32	1.175e-38 to 3.402e38
double	32	1.175e-38 to 3.402e38
*/

///////////////////////////////////////////////









































































///////////////////////////////////////////////
















































































/* 2 wire serial interface */





/* ADC */



/* Analog Comparator */


/* USART */








/* SPI */






/* EEPROM */



/* Watchdog Timer Control Register */


/* Timer/Counter 2 */



/* Timer/Counter 1 */



/* Special Function I/O register */




/* Timer/Counter 0 */


/* MCU general */



/* SPM Conrol Register */
//#define SPMCR	

/* Timer/Counter Interrupts */
//#define TIFR	
//#define TIMSK	

/* General Interrupts */
//#define GIFR	
//#define GICR	




/* Port A bits */



/* Port B bits */



/* Port C bits */



/* Port D bits */




/* Lock and Fuse Bits with LPM/SPM instructions */

/* lock bits */

/* fuses low bits */

/* fuses high bits */




































































































































// avr123.nm.ru  
 
// After #include <this file>   you can  
// use b_1010_1100 isted of 0b10101100 
 
// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);


char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-




// set your clock speed here

// you may have to experiment a little with this
// in case of heavy disturbance, try values around 60
// try to use odd values (for symmetrical level detection)

// this autoconfigures all timer values:

volatile unsigned int rc5_code = 0;
volatile unsigned char rc5_first_half;

interrupt [3] void ext_int1_isr(void)
{
 /*	external interrupt handler
	edge from IR receiver detected.
	this is assumed to be the middle of a bit.
*/
	unsigned char i;
	// resample to filter out spikes
   	if (MCUCR & (1<<2)) {
		// we were waiting for a rising edge, so cancel if we sample low
		for (i = 41  ; i; i--) if (!(PIND & (1<<3))) return;
	} else {
		// vice versa...
		for (i = 41  ; i; i--) if ((PIND & (1<<3))) return;
	}   
        TCNT0 = 0x100-((unsigned char) (4000000/64*0.0004445)); // preset timer to sample (ovf int) at second half (3/4 bit time)
	rc5_first_half = 0; // next sample will be in the second half
        TIMSK |=(1<<0); // enable timer ovf int
	GICR &=~(1<<7); // disable ext int (this handler)  
}

interrupt [12] void timer0_ovf_isr(void)
/*	timer overflow handler
	sample the present level of the interrupt line.
*/	
 {	static unsigned int rc5_shift, rc5_temp;
	static unsigned char rc5_bit = 0, level, first_level = 1;
	unsigned char i = 0, temp;
        PORTB.0^=1;
	// resample to filter out spikes
	for (temp = 41  ; temp; temp--) if (PIND & (1<<3)) i++;
	level = (i > ((unsigned char) (41  /2)));   

	if (rc5_first_half == 2) {
		// this is a timeout, cancel operation
		goto rc5_cancel;
	} else if (rc5_first_half == 1) {
		// this sample is taken in the first half of the bit (1/4 bit time)
		first_level = level; // save current level
		if (level) MCUCR &=~(1<<2); // currently at high level, wait for falling edge
		else MCUCR |=(1<<2); // currently at low level, wait for rising edge
		rc5_first_half = 2; // special code, means: next ovf int is a timeout
		GICR |=(1<<7); // much better: wait for edge ;)
		TCNT0 = 0x100-((unsigned char) (4000000/64*0.0008890)); // at timer ovf (in around 1/2 bit time) we should get a timeout
	} else {
		// this sample is taken in the second half of the bit (3/4 bit time)
		TCNT0 = 0x100-((unsigned char) (4000000/64*0.0008890)); // next sample at first half (1/4 bit time) of next bit
		rc5_first_half = 1;
		if (first_level != level) {
			// levels differ -> valid manchester encoded bit detected
			if (!rc5_bit) {
				// this is the first bit, reset values
				rc5_temp = 0;
				rc5_shift = 0x8000;
			}
			if (!level) rc5_temp |= rc5_shift; // low level (low-active) so store a '1'
			else if (rc5_bit < 2) goto rc5_cancel; // high level ('0' bit) as startbit -> error
			if (++rc5_bit == 14) {
				// reception complete, stop operation
				rc5_code = rc5_temp; 
				goto rc5_cancel;
			}
			if (rc5_shift == 0x0100) rc5_shift = 0x0020;
			else rc5_shift >>= 1;
		} else {
			// error in manchester stream -> cancel operation 
			goto rc5_cancel;
		}
	}
	return;

rc5_cancel:
	MCUCR &=~(1<<2); // falling edge
	GICR |=(1<<7); // ext. int. enabled
	GIFR &=~(1<<7); // clear an eventually set ext. int. flag
	TIMSK &=~(1<<0); // disable timer int.
	first_level = 1; // as the next ext. int. appears at the falling edge, assume the first level as high
	rc5_bit = 0;
}


void rc5_init(void){
/*	init for ext. int. and timer.
	call this once to activate the rc5 decoder.
*/
	TCCR0 = (1<<1) | (1<<0);
	DDRD &=~(1<<3); // pin is input
	PORTD &=~(1<<3); // pullup disabled (receiver has defined output)
	TIMSK &=~(1<<0); // timer ovf disabled. gets enabled by ext. int.
	MCUCR |=(1<<3); // ext. int. activated by falling edge
	MCUCR &=~(1<<2);
	GIFR = (1<<7); // clear ext. int. flag
	GICR |=(1<<7); // enable ext. int.
}

// External Interrupt 0 service routine
interrupt [2] void ext_int0_isr(void)
{
// Place your code here

}


// Declare your global variables here

void main(void)
{
// Declare your local variables here
char rc5_command,rc5_system;
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x01;
// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Low level
// INT1: Off
// INT2: Off
GICR|=0x40;
MCUCR=0x00;
MCUCSR=0x00;
GIFR=0x40;


// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: Off
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 19200
UCSRA=0x00;
UCSRB=0x08;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x0C;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// Global enable interrupts
#asm("sei");
rc5_init(); 
while (1) {
      if (rc5_code) {
      rc5_command=(unsigned char) rc5_code;
      rc5_system=(unsigned char) (rc5_code>>6);
      rc5_system&=0b00111111;
      printf("System = %i ",rc5_system);
      putsf("\r\n");
      printf("Command = %i ",rc5_command);
      putsf("\r\n");
      rc5_code = 0; // clear code
      rc5_command = 0;
      delay_ms(100);
     };	
	
}
}
